blob: 6e2acb8ef29e5003945bed17014a68b141ada454 [file] [log] [blame]
Linus Torvalds8cc6a082005-07-30 10:08:20 -07001#!/bin/sh
Fredrik Kuivinend0255242005-12-11 10:55:49 +01002
Christian Couder243a60f2008-04-11 05:55:21 +02003USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4LONG_USAGE='git bisect help
5 print this long help message.
6git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
Christian Couder38a47fd2007-04-04 07:12:02 +02007 reset bisect state and start bisection.
8git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
Christian Couder54138122008-12-02 14:53:51 +010012git bisect skip [(<rev>|<range>)...]
Christian Couder6ca8b972007-10-29 05:31:52 +010013 mark <rev>... untestable revisions.
Christian Couder38a47fd2007-04-04 07:12:02 +020014git bisect next
15 find next bisection to test and check it out.
Anders Kaseorg6b87ce22009-10-13 17:02:24 -040016git bisect reset [<commit>]
17 finish bisection search and go back to commit.
Christian Couder38a47fd2007-04-04 07:12:02 +020018git bisect visualize
19 show bisect status in gitk.
20git bisect replay <logfile>
21 replay bisection log.
22git bisect log
23 show bisect log.
24git bisect run <cmd>...
Christian Couder243a60f2008-04-11 05:55:21 +020025 use <cmd>... to automatically bisect.
26
27Please use "git help bisect" to get the full man page.'
Fredrik Kuivinend0255242005-12-11 10:55:49 +010028
Junio C Hamano8f321a32007-11-06 01:50:02 -080029OPTIONS_SPEC=
Junio C Hamanoae2b0f12005-11-24 00:12:11 -080030. git-sh-setup
Junio C Hamano4c550682007-02-05 14:03:27 -080031require_work_tree
Linus Torvalds8cc6a082005-07-30 10:08:20 -070032
Johannes Schindelince326602008-02-10 13:59:50 +000033_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35
Linus Torvalds8cc6a082005-07-30 10:08:20 -070036bisect_autostart() {
Christian Couder823ea122008-05-28 18:57:02 +020037 test -s "$GIT_DIR/BISECT_START" || {
Linus Torvalds8cc6a082005-07-30 10:08:20 -070038 echo >&2 'You need to start by "git bisect start"'
39 if test -t 0
40 then
41 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
42 read yesno
43 case "$yesno" in
44 [Nn]*)
45 exit ;;
46 esac
47 bisect_start
48 else
49 exit 1
50 fi
51 }
52}
53
54bisect_start() {
Linus Torvalds8cc6a082005-07-30 10:08:20 -070055 #
Christian Couder634f2462008-05-23 01:28:57 +020056 # Verify HEAD.
Linus Torvalds8cc6a082005-07-30 10:08:20 -070057 #
Christian Couder48949a12008-04-16 04:09:49 +020058 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
Johannes Schindelince326602008-02-10 13:59:50 +000059 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
60 die "Bad HEAD - I need a HEAD"
Linus Torvalds8cc6a082005-07-30 10:08:20 -070061
62 #
Christian Couder634f2462008-05-23 01:28:57 +020063 # Check if we are bisecting.
64 #
65 start_head=''
66 if test -s "$GIT_DIR/BISECT_START"
67 then
68 # Reset to the rev from where we started.
69 start_head=$(cat "$GIT_DIR/BISECT_START")
Christian Couderf3a186f2009-04-04 22:02:26 +020070 git checkout "$start_head" -- || exit
Christian Couder634f2462008-05-23 01:28:57 +020071 else
72 # Get rev from where we start.
73 case "$head" in
74 refs/heads/*|$_x40)
75 # This error message should only be triggered by
76 # cogito usage, and cogito users should understand
77 # it relates to cg-seek.
78 [ -s "$GIT_DIR/head-name" ] &&
79 die "won't bisect on seeked tree"
80 start_head="${head#refs/heads/}"
81 ;;
82 *)
83 die "Bad HEAD - strange symbolic ref"
84 ;;
85 esac
86 fi
87
88 #
89 # Get rid of any old bisect state.
Linus Torvalds8cc6a082005-07-30 10:08:20 -070090 #
Christian Couder823ea122008-05-28 18:57:02 +020091 bisect_clean_state || exit
Christian Couder38a47fd2007-04-04 07:12:02 +020092
93 #
94 # Check for one bad and then some good revisions.
95 #
96 has_double_dash=0
97 for arg; do
98 case "$arg" in --) has_double_dash=1; break ;; esac
99 done
Christian Couderde52f5a2009-04-24 08:29:00 +0200100 orig_args=$(git rev-parse --sq-quote "$@")
Christian Couder38a47fd2007-04-04 07:12:02 +0200101 bad_seen=0
Christian Couderd3e54c82008-04-14 05:41:45 +0200102 eval=''
Christian Couder38a47fd2007-04-04 07:12:02 +0200103 while [ $# -gt 0 ]; do
104 arg="$1"
105 case "$arg" in
106 --)
Christian Couder8fe26f42007-10-22 07:48:23 +0200107 shift
Christian Couder38a47fd2007-04-04 07:12:02 +0200108 break
109 ;;
110 *)
Christian Couder634f2462008-05-23 01:28:57 +0200111 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
Christian Couder38a47fd2007-04-04 07:12:02 +0200112 test $has_double_dash -eq 1 &&
113 die "'$arg' does not appear to be a valid revision"
114 break
115 }
Christian Couder737c74e2007-10-24 07:01:13 +0200116 case $bad_seen in
117 0) state='bad' ; bad_seen=1 ;;
118 *) state='good' ;;
119 esac
Christian Couderd3e54c82008-04-14 05:41:45 +0200120 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
Christian Couder8fe26f42007-10-22 07:48:23 +0200121 shift
Christian Couder38a47fd2007-04-04 07:12:02 +0200122 ;;
123 esac
Christian Couder8fe26f42007-10-22 07:48:23 +0200124 done
Christian Couder38a47fd2007-04-04 07:12:02 +0200125
Christian Couderba963de2008-05-23 00:39:22 +0200126 #
127 # Change state.
128 # In case of mistaken revs or checkout error, or signals received,
129 # "bisect_auto_next" below may exit or misbehave.
130 # We have to trap this to be able to clean up using
131 # "bisect_clean_state".
132 #
133 trap 'bisect_clean_state' 0
134 trap 'exit 255' 1 2 3 15
135
136 #
137 # Write new start state.
138 #
Christian Couderba963de2008-05-23 00:39:22 +0200139 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
Christian Couderde52f5a2009-04-24 08:29:00 +0200140 git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
Christian Couderba963de2008-05-23 00:39:22 +0200141 eval "$eval" &&
Miklos Vajna6c98c052008-07-11 18:01:29 +0200142 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
Christian Couderba963de2008-05-23 00:39:22 +0200143 #
144 # Check if we can proceed to the next bisect state.
145 #
Christian Couder38a47fd2007-04-04 07:12:02 +0200146 bisect_auto_next
Christian Couderba963de2008-05-23 00:39:22 +0200147
148 trap '-' 0
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700149}
150
Christian Couder55624f92007-10-24 07:01:05 +0200151bisect_write() {
152 state="$1"
153 rev="$2"
Christian Couder737c74e2007-10-24 07:01:13 +0200154 nolog="$3"
Christian Couder55624f92007-10-24 07:01:05 +0200155 case "$state" in
156 bad) tag="$state" ;;
157 good|skip) tag="$state"-"$rev" ;;
158 *) die "Bad bisect_write argument: $state" ;;
159 esac
Christian Couderba963de2008-05-23 00:39:22 +0200160 git update-ref "refs/bisect/$tag" "$rev" || exit
Johannes Schindelinf454cdc2008-02-12 19:50:57 +0000161 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
Miklos Vajna6c98c052008-07-11 18:01:29 +0200162 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
Christian Couder55624f92007-10-24 07:01:05 +0200163}
164
Christian Couderc9c4e2d2008-08-22 05:52:29 +0200165is_expected_rev() {
166 test -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
167 test "$1" = $(cat "$GIT_DIR/BISECT_EXPECTED_REV")
168}
169
Christian Couderc9c4e2d2008-08-22 05:52:29 +0200170check_expected_revs() {
171 for _rev in "$@"; do
172 if ! is_expected_rev "$_rev"; then
173 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK"
174 rm -f "$GIT_DIR/BISECT_EXPECTED_REV"
175 return
176 fi
177 done
178}
179
Christian Couderee2314f2008-11-23 22:02:49 +0100180bisect_skip() {
181 all=''
182 for arg in "$@"
183 do
184 case "$arg" in
185 *..*)
186 revs=$(git rev-list "$arg") || die "Bad rev input: $arg" ;;
187 *)
Christian Couderde52f5a2009-04-24 08:29:00 +0200188 revs=$(git rev-parse --sq-quote "$arg") ;;
Christian Couderee2314f2008-11-23 22:02:49 +0100189 esac
190 all="$all $revs"
191 done
Christian Couder1a66a482008-12-02 14:53:47 +0100192 eval bisect_state 'skip' $all
Christian Couderee2314f2008-11-23 22:02:49 +0100193}
194
Christian Couder155fc792007-10-24 07:01:21 +0200195bisect_state() {
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700196 bisect_autostart
Christian Couder155fc792007-10-24 07:01:21 +0200197 state=$1
198 case "$#,$state" in
199 0,*)
200 die "Please call 'bisect_state' with at least one argument." ;;
201 1,bad|1,good|1,skip)
202 rev=$(git rev-parse --verify HEAD) ||
203 die "Bad rev input: HEAD"
Christian Couderc9c4e2d2008-08-22 05:52:29 +0200204 bisect_write "$state" "$rev"
205 check_expected_revs "$rev" ;;
Christian Coudere3389072008-04-12 07:53:59 +0200206 2,bad|*,good|*,skip)
Christian Couder155fc792007-10-24 07:01:21 +0200207 shift
Christian Couderd3e54c82008-04-14 05:41:45 +0200208 eval=''
Christian Coudere3389072008-04-12 07:53:59 +0200209 for rev in "$@"
Christian Couder155fc792007-10-24 07:01:21 +0200210 do
Christian Coudera179a302008-04-12 02:17:36 -0700211 sha=$(git rev-parse --verify "$rev^{commit}") ||
Christian Coudere3389072008-04-12 07:53:59 +0200212 die "Bad rev input: $rev"
Christian Couderd3e54c82008-04-14 05:41:45 +0200213 eval="$eval bisect_write '$state' '$sha'; "
214 done
Christian Couderc9c4e2d2008-08-22 05:52:29 +0200215 eval "$eval"
216 check_expected_revs "$@" ;;
Christian Coudere3389072008-04-12 07:53:59 +0200217 *,bad)
218 die "'git bisect bad' can take only one argument." ;;
Junio C Hamanocc9f24d2005-08-30 12:45:41 -0700219 *)
220 usage ;;
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700221 esac
Christian Couder97e1c512007-10-22 07:48:36 +0200222 bisect_auto_next
223}
224
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700225bisect_next_check() {
Junio C Hamano0a5280a2007-04-05 23:27:44 -0700226 missing_good= missing_bad=
227 git show-ref -q --verify refs/bisect/bad || missing_bad=t
228 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
Junio C Hamano6fecf192007-04-05 22:51:14 -0700229
Junio C Hamano0a5280a2007-04-05 23:27:44 -0700230 case "$missing_good,$missing_bad,$1" in
231 ,,*)
232 : have both good and bad - ok
233 ;;
234 *,)
235 # do not have both but not asked to fail - just report.
236 false
237 ;;
238 t,,good)
239 # have bad but not good. we could bisect although
240 # this is less optimum.
241 echo >&2 'Warning: bisecting only with a bad commit.'
242 if test -t 0
243 then
244 printf >&2 'Are you sure [Y/n]? '
Francis Moreaue5d3afd2008-08-11 19:37:46 +0200245 read yesno
246 case "$yesno" in [Nn]*) exit 1 ;; esac
Junio C Hamano0a5280a2007-04-05 23:27:44 -0700247 fi
248 : bisect without good...
249 ;;
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700250 *)
Junio C Hamano0a5280a2007-04-05 23:27:44 -0700251 THEN=''
Christian Couder823ea122008-05-28 18:57:02 +0200252 test -s "$GIT_DIR/BISECT_START" || {
Junio C Hamano0a5280a2007-04-05 23:27:44 -0700253 echo >&2 'You need to start by "git bisect start".'
254 THEN='then '
255 }
256 echo >&2 'You '$THEN'need to give me at least one good' \
257 'and one bad revisions.'
258 echo >&2 '(You can use "git bisect bad" and' \
259 '"git bisect good" for that.)'
260 exit 1 ;;
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700261 esac
262}
263
264bisect_auto_next() {
Junio C Hamano434d0362005-09-17 13:51:03 -0700265 bisect_next_check && bisect_next || :
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700266}
267
268bisect_next() {
Christian Couder8fe26f42007-10-22 07:48:23 +0200269 case "$#" in 0) ;; *) usage ;; esac
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700270 bisect_autostart
Junio C Hamano0a5280a2007-04-05 23:27:44 -0700271 bisect_next_check good
272
Christian Couder08719842009-05-09 17:55:47 +0200273 # Perform all bisection computation, display and checkout
274 git bisect--helper --next-all
Christian Couder5a1d31c2009-04-19 11:56:16 +0200275 res=$?
Junio C Hamano0a5280a2007-04-05 23:27:44 -0700276
Christian Couder5a1d31c2009-04-19 11:56:16 +0200277 # Check if we should exit because bisection is finished
278 test $res -eq 10 && exit 0
Junio C Hamano0a5280a2007-04-05 23:27:44 -0700279
Christian Couder5a1d31c2009-04-19 11:56:16 +0200280 # Check for an error in the bisection process
281 test $res -ne 0 && exit $res
282
283 return 0
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700284}
285
Junio C Hamanocc9f24d2005-08-30 12:45:41 -0700286bisect_visualize() {
287 bisect_next_check fail
Junio C Hamano235997c2007-12-07 02:25:34 -0800288
289 if test $# = 0
290 then
Johannes Schindelin22b3ddd2009-01-02 19:08:00 +0100291 case "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
Junio C Hamano235997c2007-12-07 02:25:34 -0800292 '') set git log ;;
Johannes Schindelin508e84a2008-02-14 12:29:58 +0000293 set*) set gitk ;;
Junio C Hamano235997c2007-12-07 02:25:34 -0800294 esac
295 else
296 case "$1" in
297 git*|tig) ;;
298 -*) set git log "$@" ;;
299 *) set git "$@" ;;
300 esac
301 fi
302
Christian Couderfc13aa32009-11-23 05:16:14 +0100303 eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
Junio C Hamanocc9f24d2005-08-30 12:45:41 -0700304}
305
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700306bisect_reset() {
Christian Couder823ea122008-05-28 18:57:02 +0200307 test -s "$GIT_DIR/BISECT_START" || {
Christian Couderfce04992007-11-20 06:39:53 +0100308 echo "We are not bisecting."
309 return
310 }
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700311 case "$#" in
Christian Couder823ea122008-05-28 18:57:02 +0200312 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
Anders Kaseorg6b87ce22009-10-13 17:02:24 -0400313 1) git rev-parse --quiet --verify "$1^{commit}" > /dev/null ||
314 die "'$1' is not a valid commit"
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700315 branch="$1" ;;
Christian Couder8fe26f42007-10-22 07:48:23 +0200316 *)
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700317 usage ;;
318 esac
Christian Couderf3a186f2009-04-04 22:02:26 +0200319 git checkout "$branch" -- && bisect_clean_state
Junio C Hamanoe204de22005-09-10 15:18:31 -0700320}
321
Christian Couder38a47fd2007-04-04 07:12:02 +0200322bisect_clean_state() {
Christian Couder947a6042007-11-15 08:18:07 +0100323 # There may be some refs packed during bisection.
Christian Couder634f2462008-05-23 01:28:57 +0200324 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
Christian Couder947a6042007-11-15 08:18:07 +0100325 while read ref hash
326 do
Christian Couder823ea122008-05-28 18:57:02 +0200327 git update-ref -d $ref $hash || exit
Christian Couder947a6042007-11-15 08:18:07 +0100328 done
Christian Couderc9c4e2d2008-08-22 05:52:29 +0200329 rm -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
330 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
Christian Couder823ea122008-05-28 18:57:02 +0200331 rm -f "$GIT_DIR/BISECT_LOG" &&
332 rm -f "$GIT_DIR/BISECT_NAMES" &&
333 rm -f "$GIT_DIR/BISECT_RUN" &&
Christian Couder9d0cd912008-05-23 00:38:59 +0200334 # Cleanup head-name if it got left by an old version of git-bisect
Christian Couder823ea122008-05-28 18:57:02 +0200335 rm -f "$GIT_DIR/head-name" &&
336
337 rm -f "$GIT_DIR/BISECT_START"
Christian Couder38a47fd2007-04-04 07:12:02 +0200338}
339
Junio C Hamanoe204de22005-09-10 15:18:31 -0700340bisect_replay () {
Christian Couder737c74e2007-10-24 07:01:13 +0200341 test -r "$1" || die "cannot read $1 for replaying"
Junio C Hamanoe204de22005-09-10 15:18:31 -0700342 bisect_reset
Miklos Vajna6c98c052008-07-11 18:01:29 +0200343 while read git bisect command rev
Junio C Hamanoe204de22005-09-10 15:18:31 -0700344 do
Miklos Vajna6c98c052008-07-11 18:01:29 +0200345 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
346 if test "$git" = "git-bisect"; then
347 rev="$command"
348 command="$bisect"
349 fi
Junio C Hamanoe204de22005-09-10 15:18:31 -0700350 case "$command" in
351 start)
Junio C Hamanoe9a45d72005-11-27 17:42:05 -0800352 cmd="bisect_start $rev"
Christian Couder737c74e2007-10-24 07:01:13 +0200353 eval "$cmd" ;;
354 good|bad|skip)
355 bisect_write "$command" "$rev" ;;
Junio C Hamanoe204de22005-09-10 15:18:31 -0700356 *)
Christian Couder737c74e2007-10-24 07:01:13 +0200357 die "?? what are you talking about?" ;;
Junio C Hamanoe204de22005-09-10 15:18:31 -0700358 esac
359 done <"$1"
360 bisect_auto_next
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700361}
362
Christian Coudera17c4102007-03-23 08:49:59 +0100363bisect_run () {
Christian Couder83020122007-03-27 06:49:57 +0200364 bisect_next_check fail
365
Christian Coudera17c4102007-03-23 08:49:59 +0100366 while true
367 do
368 echo "running $@"
369 "$@"
370 res=$?
371
372 # Check for really bad run error.
373 if [ $res -lt 0 -o $res -ge 128 ]; then
374 echo >&2 "bisect run failed:"
375 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
376 exit $res
377 fi
378
Christian Couder155fc792007-10-24 07:01:21 +0200379 # Find current state depending on run success or failure.
Christian Couder71b02512007-10-26 05:39:37 +0200380 # A special exit code of 125 means cannot test.
381 if [ $res -eq 125 ]; then
382 state='skip'
383 elif [ $res -gt 0 ]; then
Christian Couder155fc792007-10-24 07:01:21 +0200384 state='bad'
Christian Coudera17c4102007-03-23 08:49:59 +0100385 else
Christian Couder155fc792007-10-24 07:01:21 +0200386 state='good'
Christian Coudera17c4102007-03-23 08:49:59 +0100387 fi
388
Christian Couder155fc792007-10-24 07:01:21 +0200389 # We have to use a subshell because "bisect_state" can exit.
390 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
Christian Coudera17c4102007-03-23 08:49:59 +0100391 res=$?
392
393 cat "$GIT_DIR/BISECT_RUN"
394
Junio C Hamanoe1622bf2009-11-23 15:56:32 -0800395 if sane_grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
Christian Couder71b02512007-10-26 05:39:37 +0200396 > /dev/null; then
397 echo >&2 "bisect run cannot continue any more"
398 exit $res
399 fi
400
Christian Coudera17c4102007-03-23 08:49:59 +0100401 if [ $res -ne 0 ]; then
402 echo >&2 "bisect run failed:"
Christian Couder155fc792007-10-24 07:01:21 +0200403 echo >&2 "'bisect_state $state' exited with error code $res"
Christian Coudera17c4102007-03-23 08:49:59 +0100404 exit $res
405 fi
406
Junio C Hamanoe1622bf2009-11-23 15:56:32 -0800407 if sane_grep "is the first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
Christian Coudera17c4102007-03-23 08:49:59 +0100408 echo "bisect run success"
409 exit 0;
410 fi
411
412 done
413}
414
415
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700416case "$#" in
4170)
418 usage ;;
419*)
420 cmd="$1"
421 shift
422 case "$cmd" in
Christian Couder243a60f2008-04-11 05:55:21 +0200423 help)
424 git bisect -h ;;
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700425 start)
426 bisect_start "$@" ;;
Christian Couderee2314f2008-11-23 22:02:49 +0100427 bad|good)
Christian Couder155fc792007-10-24 07:01:21 +0200428 bisect_state "$cmd" "$@" ;;
Christian Couderee2314f2008-11-23 22:02:49 +0100429 skip)
430 bisect_skip "$@" ;;
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700431 next)
432 # Not sure we want "next" at the UI level anymore.
433 bisect_next "$@" ;;
Junio C Hamano235997c2007-12-07 02:25:34 -0800434 visualize|view)
Junio C Hamanocc9f24d2005-08-30 12:45:41 -0700435 bisect_visualize "$@" ;;
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700436 reset)
437 bisect_reset "$@" ;;
Junio C Hamanoe204de22005-09-10 15:18:31 -0700438 replay)
439 bisect_replay "$@" ;;
440 log)
441 cat "$GIT_DIR/BISECT_LOG" ;;
Christian Coudera17c4102007-03-23 08:49:59 +0100442 run)
443 bisect_run "$@" ;;
Linus Torvalds8cc6a082005-07-30 10:08:20 -0700444 *)
445 usage ;;
446 esac
447esac